#include <fstream>
#include <sstream>
#include "windows.h"
using namespace std;


struct Pixel
{
	unsigned char r, g, b;
} typedef pixel_t;

char *InputBuffer;
pixel_t *InputImage;
pixel_t *OutputImage;
unsigned int Version, Width, Height, Pixels;

// converts 2D to 1D
int index(int x, int y)
{
	return ((y * Width) + x);
}

// converts 1D to 2D for X (Column)
int getx(int i)
{
	return (i % Width);
}

// converts 1D to 2D for Y (Row)
int gety(int i)
{
	return (i / Width);
}

// Wait for existance of file go.flag
void WaitForReadyFlag(void)
{
	fstream fin;
	cout << "Waiting ...\n";
	while(1)
	{
		fin.open("go.flag",ios::in);
		if( fin.is_open() )
		{
			fin.close();
			return;
		}
		Sleep(1000); // sleep 1 second
	}
}

void DeleteReadyFlag(void)
{
	remove("go.flag");
}

void WriteFinishedFlag(char *Path)
{
	cout << "Start PixMod\n";
	ofstream file (Path, ios::out|ios::binary|ios::ate);
	file << "finished";
	file.close();
}

bool ReadXMLImage(void)
{
	cout << "Read XML\n";
	// read in XML Image
	ifstream file ("image.xml", ios::in|ios::binary|ios::ate);
	if (file.is_open())
	{
		int size = file.tellg();
		InputBuffer = new char [size];
		file.seekg (0, ios::beg);
		file.read (InputBuffer, size);
		file.close();
		remove("image.xml");
		return true;
	}
	cout << "image.xml cannot be opened";
	return false;
}

// 13 and 10 are linefeed and return
// 9 is tab
// 32 is space
bool IsWhiteSpace(char *c)
{
	return (*c==13) || (*c==10) || (*c==9) || (*c==32);
}

bool InRange(int Num, int Low, int Hi)
{
	return (Num>=Low) && (Num<=Hi);
}

char *SkipWhiteSpace(char *p)
{
	while(IsWhiteSpace(p))
		p++;
	return p;
}

bool NextTag(char **p, char *Tag)
{
	char *c = *p;
	string Check;
	Check = Tag;
	string Found;
	c = SkipWhiteSpace(c);
	if (*c != '<')
	{
		cout << "Tag " << Tag << " not found.  Expected character '<' not found";
		return false;
	}
	while (*c != '>')
	{
		Found += *c;
		c++;
	}
	Found += *c;
	c++;
	*p = c;
	if (!Check.compare(Found))
		return true;
	cout << "Wrong Tag: " << Found << " found but " << Check << " expected";
	return false;
}

bool GetInt(char **p, int *n)
{
	stringstream Num;
	Num.str("");
	char *c = *p;
	c = SkipWhiteSpace(c);
	if ((*c < '0') || (*c > '9'))
	{
		cout << "Number expected.  Invalid character not within 0-9";
		return false;
	}
	while ((*c >= '0') && (*c <= '9'))
	{
		Num << *c;
		c++;
	}
	Num >> *n;
	*p = c;
	return true;
}

bool ConvertXML2Image(void)
{
	cout << "Parse XML\n";
	char *p = InputBuffer;
	int Num;
	if (!NextTag(&p, "<image>")) return false;
	if (!NextTag(&p, "<header>")) return false;
	if (!NextTag(&p, "<version>")) return false;
	if (!GetInt(&p, &Num)) return false;
	Version = Num;
	if (Version > 1)
		cout << "Warning! This is a version 1.0 module and you passed a version " << Version << ".0 image.xml file!\n";
	if (!NextTag(&p, "</version>")) return false;
	if (!NextTag(&p, "<width>")) return false;
	if (!GetInt(&p, &Num)) return false;
	Width = Num;
	if (!NextTag(&p, "</width>")) return false;
	if (!NextTag(&p, "<height>")) return false;
	if (!GetInt(&p, &Num)) return false;
	Height = Num;
	if (!NextTag(&p, "</height>")) return false;
	if (!NextTag(&p, "</header>")) return false;
	if (!NextTag(&p, "<pixels>")) return false;
	Pixels = Width * Height;
	InputImage = new Pixel [Pixels];
	OutputImage = new Pixel [Pixels];
	for (unsigned int i=0; i<Pixels; i++)
	{
		InputImage[i].r = (unsigned char)(*p);
		p++;
		InputImage[i].g = (unsigned char)(*p);
		p++;
		InputImage[i].b = (unsigned char)(*p);
		p++;
	}
	if (!NextTag(&p, "</pixels>")) return false;
	if (!NextTag(&p, "</image>")) return false;

	// free XML Image
	delete [] InputBuffer;
	return true;
}

void ConvertImage2XML(char *Path)
{
	cout << "Save XML\n";
	unsigned char r, g, b;
	ofstream file (Path, ios::out|ios::binary|ios::ate);
	file << "<image><header><version>1</version>";
	file << "<width>" << Width << "</width>";
	file << "<height>" << Height << "</height>";
	file << "</header><pixels>";	

	for (unsigned int i=0; i<Pixels; i++)
	{
		r = (unsigned char)OutputImage[i].r;
		g = (unsigned char)OutputImage[i].g;
		b = (unsigned char)OutputImage[i].b;
		file << r << g << b;
	}
	file << "</pixels></image>";
	file.close();
}
