#include <iostream>
#include "../common/funs.h"
using namespace std;

void ChangeImage(void)
{
	unsigned int x, y, i, p1, p2;
	cout << "Converting Image\n";
	// copy all pixels to output bitmaps
	for (i=0; i<Pixels; i++)
		OutputImage[i] = InputImage[i];

	// merge the rows but in reverse
	for (x=0; x<Width; x++)
	{
		for (y=0; y<Height; y++)
		{
			p1 = index(x,y);
			p2 = index(Width-x-1,y);
			OutputImage[p1].r = (unsigned int) (OutputImage[p1].r + InputImage[p2].r) / 2;
			OutputImage[p1].g = (unsigned int) (OutputImage[p1].g + InputImage[p2].g) / 2;
			OutputImage[p1].b = (unsigned int) (OutputImage[p1].b + InputImage[p2].b) / 2;
		}
	}
}


int main (int argc, char* argv[])
{
	WaitForReadyFlag();					// wait for file go.flag to appear
	DeleteReadyFlag();					// delete file go.flag
	if (!ReadXMLImage())				// read in XML Image
		return 0;						// failed to read in image
	if (!ConvertXML2Image())			// convert XML to image
		return 0;						// failed to convert XML to image
	ChangeImage();						// change image
	ConvertImage2XML("../image.xml");	// convert image to XML
	WriteFinishedFlag("../go.flag");	// write finished flag

	return 0;
}